$(function () {

    var merchantIdentifier = "example.com.store";
    var version_number = 1;

    $(".apple-pay-button").hide();
    if (window.ApplePaySession) {
        var promise = ApplePaySession.canMakePaymentsWithActiveCard(merchantIdentifier);

        promise.then(function (canMakePayments) {
            if (canMakePayments) {
                $(".apple-pay-button").show();
                $(".apple-pay-button").on('click', function () {
                    var request = {
                        countryCode: 'HK',
                        currencyCode: 'HKD',
                        supportedNetworks: ['visa', 'masterCard'],
                        merchantCapabilities: ['supports3DS'],
                        total: {label: 'Your Display Name', amount: '0.10'}
                    };

                    var session = new ApplePaySession(version_number, request);

                    session.begin();

                    session.onvalidatemerchant = function (event) {
                        var data = {
                            validationURL: event.validationURL
                        };

                        $.ajax({
                            method: "POST",
                            url: "validate-merchant.php",
                            data: data
                        }).then(function (merchantSession) {
                            session.completeMerchantValidation(JSON.parse(merchantSession));
                        });
                    };

                    session.onpaymentauthorized = function (event) {
                        var data = {
                            payment: JSON.stringify(event.payment.token.paymentData)
                        };
                        $.ajax({
                            url: "payment.php",
                            method: "POST",
                            data: data,
                            error: function (err) {
                                alert(JSON.stringify(err));
                            }
                        }).then(function (result) {
                            if (result.response.code === "200") {
                                session.completePayment(JSON.parse(ApplePaySession.STATUS_SUCCESS));
                            } else {
                                session.completePayment(JSON.parse(ApplePaySession.STATUS_FAILURE));
                            }
                        });
                    };
                });
            }

        });
    }
});